## kimageannotator 0.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(kImageAnnotator LANGUAGES CXX VERSION 0.6.0)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

option(BUILD_TESTS "Build Unit Tests" OFF)
option(BUILD_EXAMPLE "Build Example Application" ON)

include(GNUInstallDirs)

if (WIN32)
	set(KIMAGEANNOTATOR_LANG_INSTALL_DIR "translations")
elseif (APPLE)
	set(KIMAGEANNOTATOR_LANG_INSTALL_DIR "../Resources")
elseif (UNIX)
	set(KIMAGEANNOTATOR_LANG_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/kImageAnnotator/translations")
	string(REGEX REPLACE "//" "/" KIMAGEANNOTATOR_LANG_INSTALL_DIR "${KIMAGEANNOTATOR_LANG_INSTALL_DIR}")
endif ()

set(QT_MIN_VERSION 5.9.4)
find_package(Qt5 ${QT_MIN_VERSION} REQUIRED Widgets Svg)

if (UNIX AND NOT APPLE)
	find_package(X11 REQUIRED)
endif ()

include(FeatureSummary)

set(KCOLORPICKER_MIN_VERSION 0.2.0)
find_package(kColorPicker ${KCOLORPICKER_MIN_VERSION} REQUIRED)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(src)
add_subdirectory(translations)

if (BUILD_EXAMPLE)
	add_subdirectory(example)
endif (BUILD_EXAMPLE)

if (BUILD_TESTS)
	add_subdirectory(tests)
endif (BUILD_TESTS)

include(CMakePackageConfigHelpers)

add_library(kImageAnnotator
			${KIMAGEANNOTATOR_SRCS}
			${CMAKE_CURRENT_SOURCE_DIR}/include/kImageAnnotator/KImageAnnotator.h
			${CMAKE_CURRENT_SOURCE_DIR}/resources/kImageAnnotator_resources.qrc
			)

add_library(kImageAnnotator::kImageAnnotator ALIAS kImageAnnotator)

target_include_directories(kImageAnnotator
						   PUBLIC
						   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
						   $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
						   $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
						   )

target_link_libraries(kImageAnnotator PUBLIC Qt5::Widgets Qt5::Svg PRIVATE kColorPicker::kColorPicker)

if (UNIX AND NOT APPLE)
	# X11::X11 imported target only available with sufficiently new CMake
	if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.14.0)
		target_link_libraries(kImageAnnotator PRIVATE X11::X11)
	else()
		target_link_libraries(kImageAnnotator PRIVATE X11)
	endif()
endif ()

target_compile_definitions(kImageAnnotator PRIVATE KIMAGEANNOTATOR_LIB)
target_compile_definitions(kImageAnnotator PRIVATE KIMAGEANNOTATOR_LANG_INSTALL_DIR="${KIMAGEANNOTATOR_LANG_INSTALL_DIR}")

set_target_properties(kImageAnnotator
					  PROPERTIES
					  ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib
					  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib
					  RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin
					  VERSION ${PROJECT_VERSION}
					  SOVERSION 0
					  )

install(TARGETS kImageAnnotator
		EXPORT kImageAnnotator-targets
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/kImageAnnotator
		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
		)

configure_package_config_file(
		${CMAKE_CURRENT_SOURCE_DIR}/cmake/kImageAnnotatorConfig.cmake.in
		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig.cmake
		INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator
)

write_basic_package_version_file(
		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig-version.cmake
		VERSION ${PROJECT_VERSION}
		COMPATIBILITY AnyNewerVersion
)

install(FILES
		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig.cmake
		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig-version.cmake
		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator
		)

export(
		EXPORT kImageAnnotator-targets
		FILE ${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotator-targets.cmake
		NAMESPACE kImageAnnotator::
)

install(
		EXPORT kImageAnnotator-targets
		FILE kImageAnnotator-targets.cmake
		NAMESPACE kImageAnnotator::
		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator
)

# uninstall target
if(NOT TARGET uninstall)
    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
        IMMEDIATE @ONLY)

    add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

=== example/CMakeLists.txt ===
add_executable(kImageAnnotator-example main.cpp)

target_link_libraries(kImageAnnotator-example kImageAnnotator)

=== src/CMakeLists.txt ===
set(KIMAGEANNOTATOR_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/gui/KImageAnnotator.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/CoreView.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/AnnotationWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/AnnotationView.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/scrollAndZoomView/ScrollAndZoomView.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/scrollAndZoomView/ViewZoomer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/ItemSettingsWidgetConfigurator.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationSettingsAdapter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationItemSettings.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationImageSettings.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationGeneralSettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationToolSelection.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationControlsWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/docks/AnnotationDockWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/docks/AnnotationDockWidgetDragHandle.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/docks/AbstractAnnotationDockWidgetContent.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabContent.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabContextMenu.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabCloser.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabClickEventFilter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/canvasModifier/ModifyCanvasView.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/canvasModifier/ModifyCanvasWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/canvasModifier/ModifyCanvasSelectionRestrictor.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropView.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropSelectionRestrictor.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cutter/CutSelectionRestrictor.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cutter/CutView.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cutter/CutWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/SelectionHandler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/SelectionMoveHelper.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/BaseSelectionHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/SelectionHandlesAll.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/SelectionHandlesHorizontal.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/SelectionHandlesVertical.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/BaseSelectionView.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/rotator/RotateDialog.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/rotator/RotateWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/scaler/ScaleDialog.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/scaler/ScaleWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/scaler/ScaleSizeHandler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/ZoomValueProvider.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AnnotationArea.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AnnotationItemFactory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AnnotationPropertiesFactory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AbstractSettingsProvider.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/ImageEffectFactory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/NoImageEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/DropShadowImageEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/BorderImageEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/GrayscaleImageEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/InvertColorImageEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationProperties.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationPathProperties.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationTextProperties.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationObfuscateProperties.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationStickerProperties.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemModifier.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemResizer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationMultiItemResizer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemSelector.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemMover.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemArranger.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemEditor.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/AbstractItemResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/AbstractRectResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/LineResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/RectResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/PathResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/PointerRectResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/ResizeHandle.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/ResizeHandlesFactory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationItem.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationLine.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationObfuscate.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationRect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationPointerRect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationPath.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationLine.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationMarkerEllipse.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationMarkerPen.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationMarkerRect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationArrow.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationDoubleArrow.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationRect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationEllipse.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationNumber.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationNumberPointer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationNumberArrow.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationPen.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationPixelate.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationText.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationTextPointer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationTextArrow.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationBlur.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationImage.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationSticker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationDuplicate.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/BaseAnnotationNumber.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/AnnotationTextHandler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/KeyInputHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/TextCursor.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/CapsLockStatusChecker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/helper/NumberRectHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/helper/AnnotationShapeCreator.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/AddCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/DeleteCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/FlipCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/MoveCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ResizeCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ArrangeCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/CropCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/CutCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ScaleCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/RotateCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/PasteCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ChangePropertiesCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ModifyCanvasCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/itemEffects/ShadowEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/itemEffects/NoEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/ImageBlurrer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/AnnotationItemClipboard.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/AnnotationContextMenu.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/NumberManager.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/CanvasPainter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/backend/Config.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/backend/SettingsAdapter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/provider/DevicePixelRatioScaler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/provider/ScaledSizeProvider.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/CursorHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/KeyHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/MathHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/ItemHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/ShapeHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/ConfigNameHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/IconLoader.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/PathHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/filter/IgnoreShortcutsFilter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/filter/KeyEventListener.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/platform/PlatformChecker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ToolPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/Controls.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomFontComboBox.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomSpinBox.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomToolButton.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomToolButtonAction.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ToggleButton.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ColorDialogButton.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/ColorPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/NumberPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/BoolPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/FillModePicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/FontPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/SettingsPickerWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/StickerPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/ImageEffectPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/ZoomPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/GridMenu.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/GridMenuButton.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/GridMenuToolButton.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListMenuToolButton.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListMenu.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListMenuItem.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListItemGroup.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/misc/AbstractExpandingWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/misc/FlowLayout.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/misc/AttachedSeparator.cpp
	)

set(KIMAGEANNOTATOR_SRCS ${KIMAGEANNOTATOR_SRCS} PARENT_SCOPE)

=== translations/CMakeLists.txt ===
find_package(Qt5LinguistTools)

set(KIMAGEANNOTATOR_LANG_TS
	kImageAnnotator_ar.ts
	kImageAnnotator_ca.ts
	kImageAnnotator_cs.ts
	kImageAnnotator_da.ts
	kImageAnnotator_de.ts
	kImageAnnotator_el.ts
	kImageAnnotator_es.ts
	kImageAnnotator_eu.ts
	kImageAnnotator_fr.ts
	kImageAnnotator_fr_CA.ts
	kImageAnnotator_gl.ts
	kImageAnnotator_hr.ts
	kImageAnnotator_hu.ts
	kImageAnnotator_id.ts
	kImageAnnotator_it.ts
	kImageAnnotator_ja.ts
	kImageAnnotator_ko.ts
	kImageAnnotator_nl.ts
	kImageAnnotator_no.ts
	kImageAnnotator_pl.ts
	kImageAnnotator_pt.ts
	kImageAnnotator_pt_BR.ts
	kImageAnnotator_ro.ts
	kImageAnnotator_ru.ts
	kImageAnnotator_si.ts
	kImageAnnotator_sq.ts
	kImageAnnotator_sv.ts
	kImageAnnotator_tr.ts
	kImageAnnotator_uk.ts
    kImageAnnotator_zh_CN.ts)

if (DEFINED UPDATE_TS_FILES)
	qt5_create_translation(KIMAGEANNOTATOR_LANG_QM ${CMAKE_SOURCE_DIR}/translations ${KIMAGEANNOTATOR_SRCS} ${KIMAGEANNOTATOR_LANG_TS} OPTIONS "-no-obsolete")
else ()
	qt5_add_translation(KIMAGEANNOTATOR_LANG_QM ${KIMAGEANNOTATOR_LANG_TS})
endif ()

add_custom_target(translations ALL DEPENDS ${KIMAGEANNOTATOR_LANG_QM})

install(FILES ${KIMAGEANNOTATOR_LANG_QM} DESTINATION ${KIMAGEANNOTATOR_LANG_INSTALL_DIR})

=== debian/changelog ===
kimageannotator (0.6.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Thu, 26 May 2022 00:02:56 -0400

kimageannotator (0.6.0-1~exp1) experimental; urgency=medium

  * New upstream release. 
  * debian/shlibs: Tighten version requirement.

 -- Boyuan Yang <byang@debian.org>  Mon, 23 May 2022 16:01:19 -0400

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND =

export QT_SELECT := 5


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_SHARED_LIBS=ON

## kimageannotator 0.6.1

=== debian/changelog ===
kimageannotator (0.6.1-1mx21+1) mx; urgency=medium

  * Rebuild for MX-21.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Mon, 08 Jan 2024 14:25:25 -0800

kimageannotator (0.6.1-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 13 Jun 2023 12:15:57 -0400

kimageannotator (0.6.1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Thu, 23 Mar 2023 14:22:35 -0400

=== debian/control ===
Source: kimageannotator
Section: libs
Priority: optional
Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 qtbase5-dev,
 libkcolorpicker-dev (>= 0.2.0~),
 qttools5-dev-tools,
 qttools5-dev,
 libqt5svg5-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/ksnip/kImageAnnotator
Vcs-Git: https://salsa.debian.org/debian/kimageannotator.git
Vcs-Browser: https://salsa.debian.org/debian/kimageannotator

Package: libkimageannotator-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libkcolorpicker-dev,
 libkimageannotator0 (= ${binary:Version}),
 ${misc:Depends},
Description: Image Annotating Library (dev)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the development files.

Package: libkimageannotator0
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libkimageannotator-common (= ${source:Version}),
Description: Image Annotating Library (lib)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the shared library.

Package: libkimageannotator-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks: libkimageannotator0 (<< 0.3.1-3),
Replaces: libkimageannotator0 (<< 0.3.1-3),
Description: Image Annotating Library (common data files)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the architecture-independent files used by
 the library, including the translation files.

=== debian/rules ===
--- 
+++ 
@@ -21,3 +21,6 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	    -DBUILD_SHARED_LIBS=ON
+
+override_dh_strip:
+	dh_strip -a --no-automatic-dbgsym

## kimageannotator 0.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.5)
-project(kImageAnnotator LANGUAGES CXX VERSION 0.6.0)
+project(kImageAnnotator LANGUAGES CXX VERSION 0.7.1)
 
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
@@ -25,8 +25,17 @@
 	string(REGEX REPLACE "//" "/" KIMAGEANNOTATOR_LANG_INSTALL_DIR "${KIMAGEANNOTATOR_LANG_INSTALL_DIR}")
 endif ()
 
-set(QT_MIN_VERSION 5.9.4)
-find_package(Qt5 ${QT_MIN_VERSION} REQUIRED Widgets Svg)
+set(QT_MIN_VERSION 5.15.2)
+
+option(BUILD_WITH_QT6 "Build against Qt6" OFF)
+
+if (BUILD_WITH_QT6)
+	set(QT_MAJOR_VERSION 6)
+else()
+	set(QT_MAJOR_VERSION 5)
+endif()
+
+find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED Widgets Svg)
 
 if (UNIX AND NOT APPLE)
 	find_package(X11 REQUIRED)
@@ -34,8 +43,8 @@
 
 include(FeatureSummary)
 
-set(KCOLORPICKER_MIN_VERSION 0.2.0)
-find_package(kColorPicker ${KCOLORPICKER_MIN_VERSION} REQUIRED)
+set(KCOLORPICKER_MIN_VERSION 0.3.1)
+find_package(kColorPicker-Qt${QT_MAJOR_VERSION} ${KCOLORPICKER_MIN_VERSION} REQUIRED)
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR})
 
@@ -56,7 +65,7 @@
 			${KIMAGEANNOTATOR_SRCS}
 			${CMAKE_CURRENT_SOURCE_DIR}/include/kImageAnnotator/KImageAnnotator.h
 			${CMAKE_CURRENT_SOURCE_DIR}/resources/kImageAnnotator_resources.qrc
-			)
+        src/common/helper/DesktopEnvironmentChecker.cpp src/common/helper/DesktopEnvironmentChecker.h src/common/enum/DesktopEnvironmentType.h)
 
 add_library(kImageAnnotator::kImageAnnotator ALIAS kImageAnnotator)
 
@@ -64,10 +73,10 @@
 						   PUBLIC
 						   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
 						   $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
-						   $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
+						   $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/kImageAnnotator-Qt${QT_MAJOR_VERSION}>
 						   )
 
-target_link_libraries(kImageAnnotator PUBLIC Qt5::Widgets Qt5::Svg PRIVATE kColorPicker::kColorPicker)
+target_link_libraries(kImageAnnotator PUBLIC Qt${QT_MAJOR_VERSION}::Widgets Qt${QT_MAJOR_VERSION}::Svg PRIVATE kColorPicker::kColorPicker)
 
 if (UNIX AND NOT APPLE)
 	# X11::X11 imported target only available with sufficiently new CMake
@@ -98,30 +107,30 @@
 		)
 
 install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/kImageAnnotator
-		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
+		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/kImageAnnotator-Qt${QT_MAJOR_VERSION}
 		)
 
 configure_package_config_file(
 		${CMAKE_CURRENT_SOURCE_DIR}/cmake/kImageAnnotatorConfig.cmake.in
-		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig.cmake
-		INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator
+		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotator-Qt${QT_MAJOR_VERSION}Config.cmake
+		INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator-Qt${QT_MAJOR_VERSION}
 )
 
 write_basic_package_version_file(
-		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig-version.cmake
+		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotator-Qt${QT_MAJOR_VERSION}Config-version.cmake
 		VERSION ${PROJECT_VERSION}
 		COMPATIBILITY AnyNewerVersion
 )
 
 install(FILES
-		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig.cmake
-		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig-version.cmake
-		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator
+		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotator-Qt${QT_MAJOR_VERSION}Config.cmake
+		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotator-Qt${QT_MAJOR_VERSION}Config-version.cmake
+		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator-Qt${QT_MAJOR_VERSION}
 		)
 
 export(
 		EXPORT kImageAnnotator-targets
-		FILE ${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotator-targets.cmake
+		FILE ${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotator-Qt${QT_MAJOR_VERSION}-targets.cmake
 		NAMESPACE kImageAnnotator::
 )
 
@@ -129,7 +138,7 @@
 		EXPORT kImageAnnotator-targets
 		FILE kImageAnnotator-targets.cmake
 		NAMESPACE kImageAnnotator::
-		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator
+		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator-Qt${QT_MAJOR_VERSION}
 )
 
 # uninstall target

=== example/CMakeLists.txt ===
    add_executable(kImageAnnotator-example main.cpp)

target_link_libraries(kImageAnnotator-example kImageAnnotator)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -103,6 +103,7 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/KeyInputHelper.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/TextCursor.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/CapsLockStatusChecker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/TextHandlerItem.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/helper/NumberRectHelper.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/helper/AnnotationShapeCreator.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/AddCommand.cpp
@@ -137,8 +138,9 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/ConfigNameHelper.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/IconLoader.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/PathHelper.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/RectSizeHelper.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/filter/IgnoreShortcutsFilter.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/common/filter/KeyEventListener.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/common/filter/KeyEventFilter.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/platform/PlatformChecker.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ToolPicker.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/Controls.cpp
@@ -169,4 +171,6 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/misc/AttachedSeparator.cpp
 	)
 
-set(KIMAGEANNOTATOR_SRCS ${KIMAGEANNOTATOR_SRCS} PARENT_SCOPE)
+
+
+if (UNIX AND NOT APPLE)

=== translations/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,8 @@
-find_package(Qt5LinguistTools)
+find_package(Qt${QT_MAJOR_VERSION}LinguistTools)
 
 set(KIMAGEANNOTATOR_LANG_TS
 	kImageAnnotator_ar.ts
+	kImageAnnotator_bg.ts
 	kImageAnnotator_ca.ts
 	kImageAnnotator_cs.ts
 	kImageAnnotator_da.ts
@@ -33,9 +34,9 @@
     kImageAnnotator_zh_CN.ts)
 
 if (DEFINED UPDATE_TS_FILES)
-	qt5_create_translation(KIMAGEANNOTATOR_LANG_QM ${CMAKE_SOURCE_DIR}/translations ${KIMAGEANNOTATOR_SRCS} ${KIMAGEANNOTATOR_LANG_TS} OPTIONS "-no-obsolete")
+	qt_create_translation(KIMAGEANNOTATOR_LANG_QM ${CMAKE_SOURCE_DIR}/translations ${KIMAGEANNOTATOR_SRCS} ${KIMAGEANNOTATOR_LANG_TS} OPTIONS "-no-obsolete")
 else ()
-	qt5_add_translation(KIMAGEANNOTATOR_LANG_QM ${KIMAGEANNOTATOR_LANG_TS})
+	qt_add_translation(KIMAGEANNOTATOR_LANG_QM ${KIMAGEANNOTATOR_LANG_TS})
 endif ()
 
 add_custom_target(translations ALL DEPENDS ${KIMAGEANNOTATOR_LANG_QM})

=== debian/changelog ===
kimageannotator (0.7.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sun, 05 May 2024 14:41:32 -0400

kimageannotator (0.7.1-1~exp2) experimental; urgency=medium

  * debian/control: Put package under Debian KDE Extras Team maintenance.
  * debian/control: Bump Standards-Version to 4.7.0.

 -- Boyuan Yang <byang@debian.org>  Fri, 26 Apr 2024 22:00:44 -0400

kimageannotator (0.7.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/patches/0001-Make-Qt5-Qt6-library-coinstallable.patch:
    Add patch to make Qt5 and Qt6 libraries coinstallable.
  * Split package to support both Qt5 and Qt6.
    + libkimageannotator-qt5-0
    + libkimageannotator-qt6-0
    + libkimageannotator-qt5-dev
    + libkimageannotator-qt6-dev

 -- Boyuan Yang <byang@debian.org>  Wed, 20 Mar 2024 15:36:50 -0400

=== debian/control ===
Source: kimageannotator
Section: libs
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libkcolorpicker-qt5-dev (>= 0.3.1~),
 libkcolorpicker-qt6-dev (>= 0.3.1~),
 libqt5svg5-dev,
 qt6-base-dev,
 qt6-svg-dev,
 qt6-tools-dev,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/ksnip/kImageAnnotator
Vcs-Git: https://salsa.debian.org/debian/kimageannotator.git
Vcs-Browser: https://salsa.debian.org/debian/kimageannotator

Package: libkimageannotator-qt5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libkcolorpicker-qt5-dev,
 libkimageannotator-qt5-0 (= ${binary:Version}),
 ${misc:Depends},
Description: Image Annotating Library (Qt5 dev)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the Qt5 development files.

Package: libkimageannotator-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 libkimageannotator0 (<< 0.3.1-3),
Replaces:
 libkimageannotator0 (<< 0.3.1-3),
Description: Image Annotating Library (common data files)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the architecture-independent files used by
 the library, including the translation files.

Package: libkimageannotator-qt5-0
Architecture: any
Multi-Arch: same
Depends:
 libkimageannotator-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Image Annotating Library (Qt5 lib)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the Qt5 shared library.

Package: libkimageannotator-qt6-0
Architecture: any
Multi-Arch: same
Depends:
 libkimageannotator-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Image Annotating Library (Qt6 lib)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the Qt6 shared library.

Package: libkimageannotator-qt6-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libkcolorpicker-qt6-dev,
 libkimageannotator-qt6-0 (= ${binary:Version}),
 ${misc:Depends},
Description: Image Annotating Library (Qt6 dev)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the Qt6 development files.

=== debian/rules ===
--- 
+++ 
@@ -12,15 +12,21 @@
 # package maintainers to append LDFLAGS
 export DEB_LDFLAGS_MAINT_APPEND =
 
-export QT_SELECT := 5
-
-
 %:
-	dh $@
+	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure:
-	dh_auto_configure -- \
-	    -DBUILD_SHARED_LIBS=ON
+	dh_auto_configure --builddirectory=qt5 -- -DBUILD_SHARED_LIBS=ON -DBUILD_WITH_QT6=OFF
+	dh_auto_configure --builddirectory=qt6 -- -DBUILD_SHARED_LIBS=ON -DBUILD_WITH_QT6=ON
 
-override_dh_strip:
-	dh_strip -a --no-automatic-dbgsym
+override_dh_auto_build:
+	dh_auto_build --builddirectory=qt5
+	dh_auto_build --builddirectory=qt6
+
+override_dh_auto_install:
+	dh_auto_install --builddirectory=qt5
+	dh_auto_install --builddirectory=qt6
+
+override_dh_auto_test:
+	dh_auto_test --builddirectory=qt5
+	dh_auto_test --builddirectory=qt6

## kimageannotator 0.7.1+p24.04+vstable+git20250801.0438

=== debian/changelog ===
kimageannotator (0.7.1+p24.04+vstable+git20250801.0438-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 01 Aug 2025 04:38:54 +0000

kimageannotator (0.7.1-1) noble; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sun, 05 May 2024 14:41:32 -0400

## kimageannotator 0.7.1+p24.04+vstable+git20250810.0907

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(kImageAnnotator LANGUAGES CXX VERSION 0.7.1)
+project(kImageAnnotator LANGUAGES CXX VERSION 0.7.2)
 
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

=== tests/CMakeLists.txt ===
find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED Test)
find_package(GTest CONFIG REQUIRED)

enable_testing()

set(UNITTEST_SRC
	annotations/core/AnnotationAreaTest.cpp
	annotations/core/AnnotationItemFactoryTest.cpp
	annotations/core/AnnotationPropertiesFactoryTest.cpp
	annotations/modifiers/AnnotationItemResizerTest.cpp
	annotations/modifiers/AnnotationMultiItemResizerTest.cpp
	annotations/modifiers/AnnotationItemSelectorTest.cpp
	annotations/modifiers/AnnotationItemModifierTest.cpp
	annotations/modifiers/AnnotationItemArrangerTest.cpp
	annotations/modifiers/AnnotationItemMoverTest.cpp
	annotations/modifiers/resizeHandles/LineResizeHandlesTest.cpp
	annotations/modifiers/resizeHandles/RectResizeHandlesTest.cpp
	annotations/modifiers/resizeHandles/PointerRectResizeHandlesTest.cpp
	annotations/undo/AddCommandTest.cpp
	annotations/undo/DeleteCommandTest.cpp
	annotations/undo/ModifyCanvasCommandTest.cpp
	annotations/undo/MoveCommandTest.cpp
	annotations/undo/ResizeCommandTest.cpp
	annotations/undo/ArrangeCommandTest.cpp
	annotations/undo/CropCommandTest.cpp
	annotations/undo/ScaleCommandTest.cpp
	annotations/undo/PasteCommandTest.cpp
	annotations/undo/RotateCommandTest.cpp
	annotations/items/helper/KeyInputHelperTest.cpp
	annotations/items/helper/TextCursorTest.cpp
	annotations/misc/AnnotationItemClipboardTest.cpp
	annotations/misc/NumberManagerTest.cpp
	backend/ConfigTest.cpp
	common/helper/KeyHelperTest.cpp
	common/helper/MathHelperTest.cpp
	common/helper/ItemHelperTest.cpp
	common/helper/ShapeHelperTest.cpp
	common/helper/PathHelperTest.cpp
	gui/cropper/CropSelectionRestrictorTest.cpp
	gui/canvasModifier/ModifyCanvasSelectionRestrictorTest.cpp
	gui/selection/SelectionMoveHelperTest.cpp
	gui/selection/SelectionHandlerTest.cpp
	gui/selection/SelectionHandlesAllTest.cpp
	gui/scaler/ScaleSizeHandlerTest.cpp
	gui/annotator/tabs/AnnotationTabCloserTest.cpp
	gui/annotator/tabs/AnnotationTabContextMenuTest.cpp
	widgets/CustomSpinBoxTest.cpp
	widgets/misc/AttachedSeparatorTest.cpp
	widgets/settingsPicker/ToolPickerTest.cpp
	widgets/settingsPicker/ColorPickerTest.cpp
	widgets/settingsPicker/NumberPickerTest.cpp
	widgets/settingsPicker/FillModePickerTest.cpp
	widgets/settingsPicker/ImageEffectPickerTest.cpp
	widgets/settingsPicker/StickerPickerTest.cpp
	widgets/settingsPicker/ZoomPickerTest.cpp
	)

set(TESTUTILS_SRC
	utils/TestRunner.h
    mocks/gui/selection/SelectionHandlesMock.h
	mocks/backend/SettingsMock.h
    mocks/MockZoomValueProvider.cpp
	mocks/MockSettingsProvider.cpp
	mocks/MockDevicePixelRatioScaler.cpp
	mocks/MockDefaultParameters.h
	mocks/MockSelectionRestrictor.cpp
	)

add_library(KIMAGEANNOTATOR_STATIC STATIC ${KIMAGEANNOTATOR_SRCS})

target_link_libraries(KIMAGEANNOTATOR_STATIC
		Qt${QT_MAJOR_VERSION}::Widgets
		kImageAnnotator::kImageAnnotator
		kColorPicker::kColorPicker
		Qt${QT_MAJOR_VERSION}::Svg)

if (UNIX AND NOT APPLE)
	# X11::X11 imported target only available with sufficiently new CMake
	if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.14.0)
		target_link_libraries(KIMAGEANNOTATOR_STATIC X11::X11)
	else()
		target_link_libraries(KIMAGEANNOTATOR_STATIC X11)
	endif()
endif ()

target_compile_definitions(KIMAGEANNOTATOR_STATIC PRIVATE KIMAGEANNOTATOR_LANG_INSTALL_DIR="${KIMAGEANNOTATOR_LANG_INSTALL_DIR}")

foreach (UnitTest ${UNITTEST_SRC})
	get_filename_component(UnitTestName ${UnitTest} NAME_WE)
	add_executable(${UnitTestName} ${UnitTest} ${TESTUTILS_SRC})
	target_link_libraries(${UnitTestName} KIMAGEANNOTATOR_STATIC GTest::gmock Qt${QT_MAJOR_VERSION}::Test)
	add_test(${UnitTestName} ${UnitTestName})
endforeach (UnitTest)

=== debian/changelog ===
kimageannotator (0.7.1+p24.04+vstable+git20250810.0907-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 10 Aug 2025 09:07:22 +0000

=== debian/control ===
Source: kimageannotator
Section: libs
Priority: optional
Uploaders: Boyuan Yang <byang@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libkcolorpicker-qt5-dev (>= 0.3.1~),
               libkcolorpicker-qt6-dev (>= 0.3.1~),
               libqt5svg5-dev,
               qt6-base-dev,
               qt6-svg-dev,
               qt6-tools-dev,
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/ksnip/kImageAnnotator
Vcs-Git: https://invent.kde.org/neon/backports-noble/kimageannotator-noble.git
Vcs-Browser: https://invent.kde.org/neon/backports-noble/kimageannotator-noble
Maintainer: Neon CI <neon@kde.org>

Package: libkimageannotator-qt5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkcolorpicker-qt5-dev,
         libkimageannotator-qt5-0 (= ${binary:Version}),
         qtbase5-dev,
         ${misc:Depends}
Description: Image Annotating Library (Qt5 dev)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the Qt5 development files.

Package: libkimageannotator-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: libkimageannotator0 (<< 0.3.1-3)
Replaces: libkimageannotator0 (<< 0.3.1-3)
Description: Image Annotating Library (common data files)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the architecture-independent files used by
 the library, including the translation files.

Package: libkimageannotator-qt5-0
Architecture: any
Multi-Arch: same
Depends: libkimageannotator-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Image Annotating Library (Qt5 lib)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the Qt5 shared library.

Package: libkimageannotator-qt6-0
Architecture: any
Multi-Arch: same
Depends: libkimageannotator-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Image Annotating Library (Qt6 lib)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the Qt6 shared library.

Package: libkimageannotator-qt6-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkcolorpicker-qt6-dev,
         libkimageannotator-qt6-0 (= ${binary:Version}),
         qt6-base-dev,
         ${misc:Depends}
Description: Image Annotating Library (Qt6 dev)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the Qt6 development files.

## kimageannotator 0.7.1+p24.04+vstable+git20251123.0938

=== debian/changelog ===
kimageannotator (0.7.1+p24.04+vstable+git20251123.0938-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 23 Nov 2025 09:38:12 +0000

## kimageannotator 0.7.1+p24.04+vstable+git20251203.0258

=== debian/changelog ===
kimageannotator (0.7.1+p24.04+vstable+git20251203.0258-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 03 Dec 2025 02:58:44 +0000

## kimageannotator 0.7.1+p24.04+vunstable+git20251125.0134

=== debian/changelog ===
kimageannotator (0.7.1+p24.04+vunstable+git20251125.0134-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 25 Nov 2025 01:34:22 +0000

## kimageannotator 0.7.1+p24.04+vunstable+git20251203.0050

=== debian/changelog ===
kimageannotator (0.7.1+p24.04+vunstable+git20251203.0050-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 03 Dec 2025 00:50:52 +0000

## kimageannotator 0.7.2

=== debian/changelog ===
kimageannotator (0.7.2-2) unstable; urgency=medium

  * Rebuild against kcolorpicker/0.3.1-3.
  * Bump Standards-Version to 4.7.3, no changes needed.
  * debian/watch: Update to version 5.

 -- Boyuan Yang <byang@debian.org>  Wed, 31 Dec 2025 14:45:32 -0500

kimageannotator (0.7.2-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Mon, 24 Nov 2025 21:13:08 -0500

=== debian/control ===
Source: kimageannotator
Section: libs
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libkcolorpicker-qt5-dev (>= 0.3.1~),
 libkcolorpicker-qt6-dev (>= 0.3.1~),
 libqt5svg5-dev,
 qt6-base-dev,
 qt6-svg-dev,
 qt6-tools-dev,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
Standards-Version: 4.7.3
Homepage: https://github.com/ksnip/kImageAnnotator
Vcs-Git: https://salsa.debian.org/debian/kimageannotator.git
Vcs-Browser: https://salsa.debian.org/debian/kimageannotator
Description: Image Annotating Library
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.

Package: libkimageannotator-qt5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libkcolorpicker-qt5-dev,
 libkimageannotator-qt5-0 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (Qt5 dev)
 ${source:Extended-Description}
 .
 This package provides the Qt5 development files.

Package: libkimageannotator-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 libkimageannotator0 (<< 0.3.1-3),
Replaces:
 libkimageannotator0 (<< 0.3.1-3),
Description: ${source:Synopsis} (common data files)
 ${source:Extended-Description}
 .
 This package provides the architecture-independent files used by
 the library, including the translation files.

Package: libkimageannotator-qt5-0
Architecture: any
Multi-Arch: same
Depends:
 libkimageannotator-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (Qt5 lib)
 ${source:Extended-Description}
 .
 This package provides the Qt5 shared library.

Package: libkimageannotator-qt6-0
Architecture: any
Multi-Arch: same
Depends:
 libkimageannotator-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (Qt6 lib)
 ${source:Extended-Description}
 .
 This package provides the Qt6 shared library.

Package: libkimageannotator-qt6-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libkcolorpicker-qt6-dev,
 libkimageannotator-qt6-0 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (Qt6 dev)
 ${source:Extended-Description}
 .
 This package provides the Qt6 development files.

=== debian/watch ===
Version: 5

Template: Github
Owner: ksnip
Project: kimageannotator
